import * as webdriverio from 'webdriverio'

export const init = async t => {
  t.context.client = webdriverio.remote({
    host: process.env.WEBDRIVER_HOST || '0.0.0.0',
    port: process.env.WEBDRIVER_PORT || '4444',
    baseUrl: process.env.BASE_URL || 'http://localhost:8080/',
    desiredCapabilities: {
      width: 1900,
      height: 1080,
      chromeOptions: { args: [ 'window-size=1900,1080' ] },
      marionette: true
    }
  })
  await t.context.client.init()
}
export const end = async t => await t.context.client.end()
