import test from 'ava'

import { init, end } from './_webdriverio'
import page from './helpers/contact'

test.beforeEach(init)
test.afterEach.always(end)

test('failed validation messages show', async t => {
  const { client } = t.context
  await client.url(page.url)
  await client.waitForExist(page.form, 5000)
  await client.click(page.submitButton)
  let formText = await client.getText(page.form)
  t.true(formText.includes('Name is required.'))
  t.true(formText.includes('Email is required.'))
  t.true(formText.includes('Phone is required.'))
  t.true(formText.includes('Description is required.'))
  await client.setValue(page.email, 'notanaccount')
  formText = await client.getText(page.form)
  t.true(formText.includes('Please enter a valid email address.'))
})
