import test from 'ava'

import { init, end } from './_webdriverio'
import page from './helpers/patient'

test.beforeEach(init)
test.afterEach.always(end)

test('failed validation messages show', async t => {
  const { client } = t.context
  await client.url(page.url)
  await client.waitForExist(page.form, 5000)
  await client.click(page.submitButton)
  let formText = await client.getText(page.form)
  t.true(formText.includes('Name is required.'))
  t.true(formText.includes('Sex is required.'))
  t.true(formText.includes('Date of birth is required.'))
  t.true(formText.includes('Reason is required.'))
  await client.click(page.female)
  formText = await client.getText(page.form)
  t.true(formText.includes('Please specify whether you are pregnant or not.'))
})
